Bug 253837 - md root boots fail without /etc/mdadm.conf
md root boots fail without /etc/mdadm.conf
Product: Fedora
Classification: Fedora
Component: mkinitrd (Show other bugs)
All Linux
low Severity low
: ---
: ---
Assigned To: Peter Jones
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2007-08-22 06:09 EDT by Felix Bellaby
Modified: 2008-06-16 22:13 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2008-06-16 22:13:02 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Felix Bellaby 2007-08-22 06:09:44 EDT
The current versions of mkinitrd assemble root md arrays using:

mdadm -As --auto=yes --run /dev/md0

This command requires a valid /etc/mdadm.conf or /etc/mdadm/mdadm.conf file.
mkinitrd copies over any /etc/mdadm.conf to the initrd, but ignores any
/etc/mdadm/mdadm.conf file.

As a result, systems that rely on /etc/mdadm/mdadm.conf will not boot.

SOLUTION: mkinitrd should copy over /etc/mdadm/mdadm.conf from the rootfs to initrd.

Furthermore, systems that lack any mdadm.conf file will not boot (they produce
"mdadm: /dev/md0 not identified in config file." errors). These systems were
able to boot under the previous versions of mkinitrd that used the nash built-in
raidautorun (providing that they had autodetectable arrays). 

POSSIBLE SOLUTION 1: Use "mdadm --auto-detect" in the init file when mkinitrd
can not find any mdadm.conf.

POSSIBLE SOLUTION 2: Use "mdadm -A mddevice component-devices" in the init file
when mkinitrd can not find any mdadm.conf.

POSSIBLE SOLUTION 3: Create a suitable mdadm.conf on the initrd so that "mdadm
-As" will work (possibly copying this mdadm.conf onto the rootfs at the same time).

I think that SOLUTION 3 is probably the best bet. Various possible mdadm.conf
files should work, but an empty one should suffice.
Comment 1 Felix Bellaby 2007-08-22 07:12:11 EDT
After a bit of reboot testing, it seems that an empty /etc/mdadm.conf is not
enough. The minimal /etc/mdadm.conf must contain one ARRAY line giving the
component devices.

A suitable file might be generated for the ${dev} array using:

awk '/'${dev}'/ { printf "%s","ARRAY /dev/'${dev}' devices="; for (i=5; $i; i++)
printf "%s%s","/dev/"gensub("\\[.*\\]","","",$i),$(i+1) ? "," : "\n"; }'
/proc/mdstat > /etc/mdadm.conf

Of course, a suitable /etc/mdadm.conf should be in place on systems that have
one created by anaconda, but it is unwise to rely on their existence within
mkinitrd as a system that has lost its /etc/mdadm.conf might become unbootable.
Comment 2 Felix Bellaby 2007-08-22 19:02:42 EDT
A better way to generate the appropriate /etc/mdadm.conf would be to use:

mdadm -Q --detail --brief ${dev} > $MNTIMAGE/etc/mdadm.conf
Comment 3 Bug Zapper 2008-05-14 10:04:44 EDT
This message is a reminder that Fedora 7 is nearing the end of life. Approximately 30 (thirty) days from now Fedora will stop maintaining and issuing updates for Fedora 7. It is Fedora's policy to close all bug reports from releases that are no longer maintained. At that time this bug will be closed as WONTFIX if it remains open with a Fedora 'version' of '7'.

Package Maintainer: If you wish for this bug to remain open because you plan to fix it in a currently maintained version, simply change the 'version' to a later Fedora version prior to Fedora 7's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that we may not be able to fix it before Fedora 7 is end of life. If you would still like to see this bug fixed and are able to reproduce it against a later version of Fedora please change the 'version' of this bug. If you are unable to change the version, please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's lifetime, sometimes those efforts are overtaken by events. Often a more recent Fedora release includes newer upstream software that fixes bugs or makes them obsolete. If possible, it is recommended that you try the newest available Fedora distribution to see if your bug still exists.

Please read the Release Notes for the newest Fedora distribution to make sure it will meet your needs:

The process we are following is described here: http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 Bug Zapper 2008-06-16 22:13:00 EDT
Fedora 7 changed to end-of-life (EOL) status on June 13, 2008. 
Fedora 7 is no longer maintained, which means that it will not 
receive any further security or bug fix updates. As a result we 
are closing this bug. 

If you can reproduce this bug against a currently maintained version 
of Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.